<?php

namespace App\Http\Controllers\Amazon;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Http;
use Action;
use config;

class DecrumActionableController extends Controller
{
    public function __construct()
    {
        $this->jsonFile = config('keylist.decrum.action_storage_path');
        $this->resFile = storage_path('amazonspapi/decrumact/decrum_response.json');
        $this->AMAZON_CLIENT_ID_DECRUM = config('keylist.decrum.client_id');
        $this->AMAZON_CLIENT_SECRET_DECRUM  = config('keylist.decrum.client_secret');
        $this->AMAZON_REFRESH_TOKEN_DECRUM =  config('keylist.decrum.refresh_token');
    }

    public function getActAccessToken()
    {
        $clientId = $this->AMAZON_CLIENT_ID_DECRUM;
        $clientSecret = $this->AMAZON_CLIENT_SECRET_DECRUM;
        $refreshToken = $this->AMAZON_REFRESH_TOKEN_DECRUM;
        return Action::getAccessToken($clientId,$clientSecret,$refreshToken,$this->jsonFile);
    }

    public function requestActReport()
    {
        return Action::requestActReport($this->jsonFile);
    }

    public function checkActReportStatus()
    {
        return Action::checkActReportStatus($this->jsonFile);
    }

    public function downloadActReport()
    {
        $url = 'https://esirenext.com/next/api/decrumActionDbApi';
        return Action::downloadActReport($this->jsonFile,$url,$this->resFile);
    }
}
