<?php

namespace App\Http\Controllers\MCF;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Http;
use MCF;
use config;

class MCFController extends Controller{
    
    public function __construct(){
        ///credentials
        
        ///decrum
        $this->JSON_FILE_DECRUM = config('keylist.decrum.mcf_access_token_path');
        $this->AMAZON_CLIENT_ID_DECRUM = config('keylist.decrum.client_id');
        $this->AMAZON_CLIENT_SECRET__DECRUM  = config('keylist.decrum.client_secret');
        $this->AMAZON_REFRESH_TOKEN_DECRUM =  config('keylist.decrum.refresh_token');
        $this->MARKET_PLACE_ID_US_DECRUM =  config('keylist.decrum.market_place_id_us');
        $this->MARKET_PLACE_ID_CA_DECRUM =  config('keylist.decrum.market_place_id_ca');
        
        ///blingsoul
        $this->JSON_FILE_BLINGSOUL = config('keylist.blingsoul.mcf_access_token_path');
        $this->AMAZON_CLIENT_ID_BLINGSOUL = config('keylist.blingsoul.client_id');
        $this->AMAZON_CLIENT_SECRET__BLINGSOUL  = config('keylist.blingsoul.client_secret');
        $this->AMAZON_REFRESH_TOKEN_BLINGSOUL =  config('keylist.blingsoul.refresh_token');
        $this->MARKET_PLACE_ID_US_BLINGSOUL =  config('keylist.blingsoul.market_place_id_us');
        $this->MARKET_PLACE_ID_CA_BLINGSOUL =  config('keylist.blingsoul.market_place_id_ca');
        
        ///fjackets
        $this->JSON_FILE_FJACKETS = config('keylist.fjackets.mcf_access_token_path');
        $this->AMAZON_CLIENT_ID_FJACKETS = config('keylist.fjackets.client_id');
        $this->AMAZON_CLIENT_SECRET__FJACKETS  = config('keylist.fjackets.client_secret');
        $this->AMAZON_REFRESH_TOKEN_FJACKETS =  config('keylist.fjackets.refresh_token');
        $this->MARKET_PLACE_ID_US_FJACKETS =  config('keylist.fjackets.market_place_id_us');
        $this->MARKET_PLACE_ID_CA_FJACKETS =  config('keylist.fjackets.market_place_id_ca');
        
        ////Axfashion
        $this->JSON_FILE_AXFASHION = config('keylist.axfashion.mcf_access_token_path');
        $this->AMAZON_CLIENT_ID_AXFASHION = config('keylist.axfashion.client_id');
        $this->AMAZON_CLIENT_SECRET__AXFASHION  = config('keylist.axfashion.client_secret');
        $this->AMAZON_REFRESH_TOKEN_AXFASHION =  config('keylist.axfashion.refresh_token');
        $this->MARKET_PLACE_ID_US_AXFASHION =  config('keylist.axfashion.market_place_id_us');
        $this->MARKET_PLACE_ID_CA_AXFASHION =  config('keylist.axfashion.market_place_id_ca');
    }

    public function getActAccessToken($store){
        
        if($store =='decrum' || $store =='decrumca' || $store=='Amazon Decrum'){
            $clientId = $this->AMAZON_CLIENT_ID_DECRUM;
            $clientSecret = $this->AMAZON_CLIENT_SECRET__DECRUM;
            $refreshToken = $this->AMAZON_REFRESH_TOKEN_DECRUM;
            $jsonFile = $this->JSON_FILE_DECRUM;
            $marketplace_id=$this->MARKET_PLACE_ID_US_DECRUM;
            
            if($store =='decrumca'){
                $marketplace_id=$this->MARKET_PLACE_ID_CA_DECRUM;
            }
            
            
            
        }else if ($store =='blingsoul' || $store =='blingsoulca' || $store=='Shahzad A/C'){
            $clientId = $this->AMAZON_CLIENT_ID_BLINGSOUL;
            $clientSecret = $this->AMAZON_CLIENT_SECRET__BLINGSOUL;
            $refreshToken = $this->AMAZON_REFRESH_TOKEN_BLINGSOUL;
            $jsonFile = $this->JSON_FILE_BLINGSOUL;
            $marketplace_id=$this->MARKET_PLACE_ID_US_BLINGSOUL;
            
            if($store =='blingsoulca'){
                $marketplace_id=$this->MARKET_PLACE_ID_CA_BLINGSOUL;
            }
            
        }else if ($store =='fjackets' || $store=='Amazon Fjackets'){
            $clientId = $this->AMAZON_CLIENT_ID_FJACKETS;
            $clientSecret = $this->AMAZON_CLIENT_SECRET__FJACKETS;
            $refreshToken = $this->AMAZON_REFRESH_TOKEN_FJACKETS;
            $jsonFile = $this->JSON_FILE_FJACKETS;
            $marketplace_id=$this->MARKET_PLACE_ID_US_FJACKETS;
            
        }else if ($store =='axfashion' || $store=='Amazon AxFashions'){
            $clientId = $this->AMAZON_CLIENT_ID_AXFASHION;
            $clientSecret = $this->AMAZON_CLIENT_SECRET__AXFASHION;
            $refreshToken = $this->AMAZON_REFRESH_TOKEN_AXFASHION;
            $jsonFile = $this->JSON_FILE_AXFASHION;
            $marketplace_id=$this->MARKET_PLACE_ID_US_AXFASHION;
            
        }
        
        
        
        MCF::getAccessToken($clientId,$clientSecret,$refreshToken,$jsonFile);
        
        $arr=[
            'jsonFile' => $jsonFile,
            'marketplace_id' => $marketplace_id
        ];
        return $arr;
    }

    public function getFullFillmentPreview(Request $request){
        $auth_token=request()->bearerToken();
        
        if($auth_token =='n11hnvR1nd]RCxq-Ld5F^=#b!1{+w8q$Eod'){
            $input=$request->json()->all();
            $store= $input['data']['store'];
            $data=$input['data'];
            
        
            $arr=$this->getActAccessToken($store);
            $jsonFilePath = $arr['jsonFile'];
            $marketplace_id = $arr['marketplace_id']; 
            $getData = json_decode(file_get_contents($jsonFilePath), true);
            $access_token = $getData['access_token'];
            
            
            
            $data = array(
                'order_no' => $data['order_no'],
                'reference_no' => $data['reference_no'],
                'order_sku' => $data['order_sku'],
                'address_name' => $data['billing_name'],
                'address_line1' => $data['address1'],
                'address_line2' => $data['address2'],
                'city' => $data['city'],
                'state' => $data['state'], 
                'zip_code' => $data['zip_code'],
                'country_code' => $data['country_code'],
                'asin' => $data['selected_asin'],
                'quantity' => $data['quantity'],
                'created_date' => date('Y-m-d H:i:s'),
                'opex_user_id' => $input['user_id'],
                'opex_user_name' => $input['user_name'],
                'store' => $store,
                'amazon_sku' => $data['amazon_sku'],
                'state_code' => $data['state_code']
            );
            
            
            
            $data=MCF::fullFillmentPreview($access_token,$marketplace_id,$data);
            
            return response()->json(['code' => '200','data' => $data]);
        }
        
        
    }
    
    //create order in amazon
    public function createFullFillmentOrder(Request $request){
        $auth_token=request()->bearerToken();
        
        
        if($auth_token =='n11hnvR1nd]RCxq-Ld5F^=#b!1{+w8q$Eod'){
            $input=$request->json()->all();
            $store= $input['data']['store'];
            $data=$input['data'];
            
            $arr=$this->getActAccessToken($store);
            $jsonFilePath = $arr['jsonFile'];
            $marketplace_id = $arr['marketplace_id']; 
            $getData = json_decode(file_get_contents($jsonFilePath), true);
            $access_token = $getData['access_token'];
            
            $data = array(
                'order_no' => $data['order_no'],
                'reference_no' => $data['reference_no'],
                'order_sku' => $data['order_sku'],
                'address_name' => $data['billing_name'],
                'address_line1' => $data['address1'],
                'address_line2' => $data['address2'],
                'city' => $data['city'],
                'state' => $data['state'],
                'zip_code' => $data['zip_code'],
                'country_code' => $data['country_code'],
                'phone' => $data['phone_no'],
                'asin' => $data['selected_asin'],
                'quantity' => $input['quantity'],
                'created_date' => date('Y-m-d H:i:s'),
                'opex_user_id' => $input['user_id'],
                'opex_user_name' => $input['user_name'],
                'store' => $store,
                'amazon_sku' => $data['amazon_sku'],
                'state_code' => $data['state_code'],
                'speed' => $input['speed']
            );
            
            
            $data=MCF::createFullFillment($access_token,$marketplace_id,$data);
            return response()->json(['code' => '200','data' => $data]);
        }
        
        
        
    }
    
    //create order in amazon (Check tracking and shipped)
    public function getFullFillmentOrder(Request $request){
        $auth_token=request()->bearerToken();
        
        
        if($auth_token =='n11hnvR1nd]RCxq-Ld5F^=#b!1{+w8q$Eod'){
            $input=$request->json()->all();
            
            $store= $input['store'];
            $data=$input['order_no'];
            
            $arr=$this->getActAccessToken($store);
            $jsonFilePath = $arr['jsonFile'];
            $marketplace_id = $arr['marketplace_id']; 
            $getData = json_decode(file_get_contents($jsonFilePath), true);
            $access_token = $getData['access_token'];
            
            $data = array(
                'order_no' => $data//542375-E
            );
            
            $data=MCF::getFullFillmentOrder($access_token,$marketplace_id,$data);
            return response()->json(['code' => '200','data' => $data]);
        }
        
        
        
    }
    
    //cancel order
    public function cancelFullFillmentOrder(Request $request){
        $auth_token=request()->bearerToken();
        
        if($auth_token =='n11hnvR1nd]RCxq-Ld5F^=#b!1{+w8q$Eod'){
            $input=$request->json()->all();
            
            $store= $input['store'];
            $data=$input['order_no'];
            
            $arr=$this->getActAccessToken($store);
            $jsonFilePath = $arr['jsonFile'];
            $marketplace_id = $arr['marketplace_id']; 
            $getData = json_decode(file_get_contents($jsonFilePath), true);
            $access_token = $getData['access_token'];
            
            $data = array(
                'order_no' => $data//542375-E
            );
            
            $data = MCF::cancelFullFillment($access_token,$marketplace_id,$data);
            // return $data;
            return response()->json(['code' => '200','data' => $data]);
        }
    }
    
    ///send tracking in Amazon or 
    public function submitFeed(){
        $marketplace_ids=[];
        $marketplace_ids[]=$this->MARKET_PLACE_ID_US_DECRUM;
        $marketplace_ids[]=$this->MARKET_PLACE_ID_CA_DECRUM;
        
        $this->getActAccessToken('decrum');
        $jsonFilePath = $this->JSON_FILE_DECRUM;
        
        $getData = json_decode(file_get_contents($jsonFilePath), true);
        $access_token = $getData['access_token'];
        
        // echo $access_token;exit;
        
        $data = array(
            'reference_no' => '111-5943162-6691461',
            'shipment_date' => '2023-10-05',
            'carrier' => 'USPS',
            'service' => 'USPS Priority Mail',
            'tracking_number' => '92346903332000300006197965'
        );
        
        MCF::submitFeed($access_token,$marketplace_ids,$data);
        return response()->json(['code' => '200']);
    }
}
