<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Mail\Mailables\Content;
use Illuminate\Mail\Mailables\Envelope;
use Illuminate\Queue\SerializesModels;

class StockInfoEmail extends Mailable
{
    use Queueable, SerializesModels;
    protected $resfile;
    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($resfile)
    {
        $this->resfile = $resfile;
    }

    /**
     * Get the message envelope.
     *
     * @return \Illuminate\Mail\Mailables\Envelope
     */
    public function build()
    {
        return $this->subject('Amazon Inventory Stock')
        ->view('emails.attachment')
        ->attachData(file_get_contents($this->resfile), 'amazonstockinfo.json');
    }
}
